
/*
 * This file implements initial version of device-mapper zero target.
 */
#include <sys/types.h>
#include <sys/param.h>

#include <sys/buf.h>
#include <sys/errno.h>
#include <sys/ioctl.h>
#include <sys/ioccom.h>
#include <sys/kmem.h>
#include <sys/types.h>
#include <sys/param.h>
#include <sys/queue.h>

#include "dm.h"


int
dm_target_zero_init(struct dm_dev *dmv, void **target_config, int argc, char **argv)
{

	printf("Zero target init function called!!\n");

	*target_config = NULL;
	
	return 0;
}

int
dm_target_zero_strategy(struct dm_table_entry *table_en, struct buf *bp)
{

	printf("Zero target read function called %d!!\n",bp->b_bcount);

	memset(bp->b_data, 0, bp->b_bcount); 
	bp->b_resid = 0; /* nestiobuf_done wants b_resid = 0 to be sure
			    that there is no other io to done  */
	
	biodone(bp);

	return 0;
}

int
dm_target_zero_destroy(struct dm_table_entry *table_en)
{
	
	return 0;
}

int
dm_target_zero_upcall(struct dm_table_entry *table_en, struct buf *bp)
{

	return 0;
}

